Index: gli/branches/rtl-gli/src/org/greenstone/gatherer/cdm/DepositorMetadataManager.java
===================================================================
--- gli/branches/rtl-gli/src/org/greenstone/gatherer/cdm/DepositorMetadataManager.java	(revision 18352)
+++ gli/branches/rtl-gli/src/org/greenstone/gatherer/cdm/DepositorMetadataManager.java	(revision 18352)
@@ -0,0 +1,527 @@
+/**
+ *#########################################################################
+ *
+ * A component of the Gatherer application, part of the Greenstone digital
+ * library suite from the New Zealand Digital Library Project at the
+ * University of Waikato, New Zealand.
+ *
+ * Author: John Thompson, Greenstone Digital Library, University of Waikato
+ *
+ * Copyright (C) 1999 New Zealand Digital Library Project
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *########################################################################
+ */
+package org.greenstone.gatherer.cdm;
+
+import java.awt.BorderLayout;
+import java.awt.Color;
+import java.awt.Component;
+import java.awt.Dimension;
+import java.awt.event.ActionEvent;
+import java.awt.event.ActionListener;
+import java.io.File;
+import java.util.ArrayList;
+
+import javax.swing.BorderFactory;
+import javax.swing.BoxLayout;
+import javax.swing.JCheckBox;
+import javax.swing.JComboBox;
+import javax.swing.JComponent;
+import javax.swing.JOptionPane;
+import javax.swing.JPanel;
+import javax.swing.JScrollPane;
+
+import org.greenstone.gatherer.Configuration;
+import org.greenstone.gatherer.Dictionary;
+import org.greenstone.gatherer.Gatherer;
+import org.greenstone.gatherer.collection.CollectionManager;
+import org.greenstone.gatherer.gui.DesignPaneHeader;
+import org.greenstone.gatherer.gui.GComboBox;
+import org.greenstone.gatherer.metadata.MetadataElement;
+import org.greenstone.gatherer.metadata.MetadataSet;
+import org.greenstone.gatherer.metadata.MetadataSetManager;
+import org.greenstone.gatherer.util.Utility;
+
+/**
+ * This manager implements the "Depositor Metadata" section in GLI Format Panel, where 
+ * users can customize which metadata elements will be used to describe an item when deposited in the Depositor.
+ *      
+ * @author Anna Huang, Greenstone Digital Library, University of Waikato
+ * @version 1.0
+ */
+public class DepositorMetadataManager {
+    /** Display controls of the element */
+    static private Dimension LABEL_SIZE = new Dimension(150, 15);
+    static private Dimension ROW_SIZE = new Dimension(400, 20);
+    
+    /** Available types, corresponds to the HTML input types */ 
+    static private String[] TYPEOPTIONS = new String[]{"text", "textarea"};
+    /** Default elements to be used in Depositor */
+    static private String DEFAULT_METADATA_ELEMENTS = "dc.Title, dc.Creator, dc.Description";
+    /** Definition attribute of a metadata element */ 
+    static private String DEFINITION = "definition";
+    
+    /** Display controls */
+    private Control controls;	
+    /** List of MetadataElementEntry objects, each represents a metadata element */
+    private ArrayList metadata_checklist_model = null;	
+    /** Collection configuration file manager */ 
+    private CollectionMetaManager collmeta_manager = CollectionDesignManager.collectionmeta_manager;
+    
+    public DepositorMetadataManager() {
+    }
+    
+    /** Destructor. */
+    public void destroy() {
+	if (controls != null) {
+	    controls.destroy();
+	    controls = null;
+	}
+	if(metadata_checklist_model != null) {
+	    metadata_checklist_model.clear();
+	    metadata_checklist_model = null;
+	}
+    }
+		
+    public Control getControls() {
+	if (controls == null) {
+	    controls = new DepositorControl();
+	}
+	return controls;
+    }
+	
+    /** Called when the detail mode has changed which in turn may cause several design elements to be available/hidden
+     * @param mode the new mode as an int
+     */
+    public void modeChanged(int mode) {
+    }
+	
+    /**
+     * The implementation of this display control is similar to the <code>ArgumentConfiguration</code>, 
+     * where each component in the central panel is another JPanel component consists of a checkbox and a drop down list. 
+     */
+    private class DepositorControl
+	extends JPanel
+	implements Control {		
+		
+	private JPanel central_pane = null;
+
+	public DepositorControl() {
+	    super();
+
+	    JPanel header_panel = new DesignPaneHeader("CDM.GUI.DepositorMetadata", "depositormetadatasettings");
+			
+	    // load all possible metadata sets, and existing configuration
+	    buildModel();
+	    
+	    central_pane = new JPanel();
+	    central_pane.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));
+	    central_pane.setLayout(new BoxLayout(central_pane, BoxLayout.Y_AXIS));	
+									
+	    // build the central pane, ie. create gui component for each metadata element 
+	    buildPane();		
+
+	    JPanel collection_checklist_pane = new JPanel();
+	    collection_checklist_pane.setBorder(BorderFactory.createEmptyBorder(5,0,0,0));
+	    collection_checklist_pane.setLayout(new BorderLayout());
+	    collection_checklist_pane.add(new JScrollPane(central_pane), BorderLayout.CENTER);
+
+	    setBorder(BorderFactory.createEmptyBorder(0,5,0,0));
+	    setLayout(new BorderLayout());
+	    add(header_panel, BorderLayout.NORTH);
+	    add(collection_checklist_pane, BorderLayout.CENTER);
+	}
+		
+	public void destroy() {
+	}
+
+	public void gainFocus() {
+	}
+		
+	public void loseFocus() {			
+	    StringBuffer converted_javascript = new StringBuffer();
+			
+	    // get currently selected metadata elements and create the javascript associative array variable
+	    if (metadata_checklist_model != null) {
+		int size = metadata_checklist_model.size();
+		for(int i = 0; i < size; i++) {				
+		    MetadataElementEntry entry = (MetadataElementEntry) metadata_checklist_model.get(i);
+					
+		    if (entry.isSelected()) {					
+			StringBuffer element = new StringBuffer();
+			element.append("{\"name\":\"").append(entry.name).append("\",");
+			element.append("\"label\":\"").append(entry.label).append("\",");
+			element.append("\"tooltip\":\"").append(entry.name).append(": ").append(entry.tooltip).append("\",");
+			element.append("\"type\":\"").append(entry.getType()).append("\"}");
+			if(converted_javascript.length() != 0) {
+			    converted_javascript.append(", ");
+			}
+			converted_javascript.append(element);
+			element = null;
+		    }				
+		}
+				
+		// if none of the elements were selected, use the default setting				
+		if (converted_javascript.length() == 0) {
+		    System.err.println("Error: DepositorMetadataMananger should have at least one selected metadata element.");
+		}
+
+		// save to the configuration file
+		CollectionMeta depositor_metadata_meta = collmeta_manager.getMetadatum("depositormetadata", true);
+		depositor_metadata_meta.setValue(converted_javascript.toString());			
+	    }		
+	}
+		
+	private void buildModel()
+	{
+	    metadata_checklist_model = new ArrayList();
+	    String current_coll_name = CollectionManager.getLoadedCollectionName();
+			
+	    // get the elements that have already been used in depositor
+	    // add the "depositormetadata" meta if not found in the configuration file
+	    CollectionMeta depositor_metadata_meta = collmeta_manager.getMetadatum("depositormetadata", true);			
+	    String selected_metadata_javascript = depositor_metadata_meta.getValue(true);
+			
+	    // load all MDSets in the collection, ie. .mds files in the collection's metadata directory
+	    String file_name = Gatherer.getCollectDirectoryPath() + File.separator + current_coll_name + File.separator + "metadata";
+	    ArrayList metadata_sets = MetadataSetManager.listMetadataSets(new File(file_name));
+	    
+	    // if the collection doesn't have a metadata directory, load all the MDSets in the global GLI/metadata directory 
+	    if (metadata_sets == null) {
+		file_name = org.greenstone.gatherer.gems.MetadataSetManager.getGLIMetadataDirectoryPath();
+		metadata_sets = MetadataSetManager.listMetadataSets(new File(file_name));
+	    } 
+			
+	    // always load the dc mds
+	    boolean found = false;
+	    for (int i = 0, j = metadata_sets.size(); i < j; i++) {
+		if (((MetadataSet) metadata_sets.get(i)).getNamespace().equals("dc")) {
+		    found = true;
+		    break;
+		}					
+	    }
+	    if (found == false) {
+		file_name = org.greenstone.gatherer.gems.MetadataSetManager.getGLIMetadataDirectoryPath();
+		file_name += "dublin.mds";
+		File dublin_mds_file = new File(file_name);
+		if (dublin_mds_file.exists()) {
+		    MetadataSetManager.loadMetadataSet(dublin_mds_file);					
+		    metadata_sets = MetadataSetManager.getMetadataSets();
+		}
+	    }			
+
+	    // unload the ex mds
+	    for (int i = 0, j = metadata_sets.size(); i < j; i++) {
+		if (((MetadataSet) metadata_sets.get(i)).getNamespace().equals("ex")) {
+		    metadata_sets.remove(i);
+		    break;
+		}
+	    }
+			
+	    if (metadata_sets == null) {
+		System.err.println("Error: DepositorMetadataMananger can't find any valid metadata set files.");
+		return;
+	    }			
+			
+	    // load all the metadata elements
+	    for (int i = 0, j = metadata_sets.size(); i < j; i++) {
+		MetadataSet metadata_set = (MetadataSet) metadata_sets.get(i);				
+		ArrayList elements = metadata_set.getMetadataSetElements(); 
+		
+		for (int k = 0; elements != null && k < elements.size(); k++) {
+		    MetadataElement element = (MetadataElement) elements.get(k);
+		    // all names are language independent at the moment. 
+		    MetadataElementEntry entry = new MetadataElementEntry (element.getFullName(), element.getName(), false);
+		    entry.setToolTip(element.getAttribute(DEFINITION, "en"));
+		    metadata_checklist_model.add(entry);
+		}
+	    }	
+	    
+	    if (!selected_metadata_javascript.equals("")) {
+		for (int i = 0, j = metadata_checklist_model.size(); i < j; i++) {
+		    MetadataElementEntry entry = (MetadataElementEntry) metadata_checklist_model.get(i);
+		    
+		    String temp = "\"name\":\"" + entry.name + "\"";
+		    if (selected_metadata_javascript.indexOf(temp) != -1) {
+			entry.setSelected(true);
+			entry.type = getValueFromJSAssociatedArray(selected_metadata_javascript, entry.name, "type");						
+		    }
+		    temp = null;
+		}	
+	    } else {				
+		// use default elements				
+		for (int i = 0, j = metadata_checklist_model.size(); i < j; i++) {
+		    MetadataElementEntry entry = (MetadataElementEntry) metadata_checklist_model.get(i);
+		    if (DEFAULT_METADATA_ELEMENTS.indexOf(entry.name) != -1) {
+			entry.setSelected(true);
+			entry.type = TYPEOPTIONS[0];
+		    }
+		}
+	    }					
+	}	
+	
+	private void buildPane() {
+	    // use different background color for two adjacent metadata sets
+	    String current_namespace = null;
+	    String current_bgcolor_name = null;
+	    for (int i = 0, j = metadata_checklist_model.size(); i < j; i++) {
+		MetadataElementEntry entry = (MetadataElementEntry) metadata_checklist_model.get(i);
+		
+		if (current_namespace == null) {
+		    current_namespace = entry.namespace;
+		    current_bgcolor_name = "coloring.collection_tree_background";
+		} else {
+		    if (!entry.namespace.equals(current_namespace)) {
+			current_namespace = entry.namespace;
+			current_bgcolor_name = (current_bgcolor_name == "coloring.collection_tree_background") ? "coloring.collection_heading_background" : "coloring.collection_tree_background";
+		    }
+		}			
+		
+		if (entry.getGUIControl() == null) {
+		    MetadataElementControl element_control = entry.initGUIControl(current_bgcolor_name);					
+		    central_pane.add(element_control, BorderLayout.NORTH);
+		}				
+	    }
+	    
+	}
+		
+	/**
+	 * Retrieve the value for the specified element in the given javascript associative array expression
+	 *  
+	 * @param text
+	 * @param identifier
+	 * @param elem_name
+	 * @return
+	 */
+	private String getValueFromJSAssociatedArray(String text, String identifier, String elem_name) {
+	    int p = text.indexOf(elem_name, text.indexOf(identifier));
+	    if (p == -1) {
+		return null;
+	    }
+	    p = text.indexOf("\":\"", p);
+	    if (p == -1) {
+		return null;
+	    }
+	    p += 3;
+			
+	    return text.substring(p, text.indexOf("\"", p));			
+	}
+    }
+	
+    private class MetadataElementControl extends JPanel {
+	
+	private JCheckBox enabled = null;
+	private JComponent value_control = null;		
+		
+	public MetadataElementControl (MetadataElementEntry entry, String background_color_name) {
+						
+	    String tip = "<html>" + entry.tooltip + "</html>";
+	    tip = Utility.formatHTMLWidth(tip, 80);
+	    
+	    setBackground(Configuration.getColor(background_color_name, false));
+	    setBorder(BorderFactory.createEmptyBorder(0,0,0,0));
+	    setLayout(new BorderLayout());
+	    setPreferredSize(ROW_SIZE);
+			
+	    // the checkbox component
+	    enabled = new JCheckBox(entry.name);
+	    enabled.setSelected(entry.selected);
+	    enabled.setOpaque(false);
+	    enabled.setPreferredSize(LABEL_SIZE);
+	    enabled.setToolTipText(entry.tooltip);
+	    add(enabled, BorderLayout.WEST);
+			
+	    // the drop down list component
+	    ArrayList option_list = new ArrayList();
+	    for (int i = 0; i < TYPEOPTIONS.length; i++) {
+		option_list.add(TYPEOPTIONS[i]);
+	    }
+	    value_control = new GComboBox(option_list.toArray(), false, false);
+	    selectValue((JComboBox)value_control, entry.type); 
+	    value_control.setOpaque(true);			
+	    if (entry.selected) { 
+		value_control.setBackground(Color.white);
+		value_control.setEnabled(true);
+	    } else {
+		value_control.setBackground(Color.lightGray);
+		value_control.setEnabled(false);
+		value_control.setVisible(false);
+	    }							
+	    add(value_control, BorderLayout.CENTER);
+	    
+	    enabled.addActionListener(new EnabledListener(value_control));
+	}
+				
+	private boolean selectValue(JComboBox combobox, String target) {
+	    if (target == null) {
+		combobox.setSelectedIndex(0);
+		return false;
+	    }
+			
+	    for (int i = 0; i < combobox.getItemCount(); i++) {				
+		if (combobox.getItemAt(i).toString().equals(target)) {
+		    combobox.setSelectedIndex(i);
+		    return true;
+		}
+	    }
+	    return false;
+	}
+		
+	private class EnabledListener
+	    implements ActionListener {			
+	    private JComponent target = null;
+	    
+	    public EnabledListener(JComponent target) {
+		this.target = target;
+	    }
+	    
+	    public void actionPerformed(ActionEvent event) {
+		JCheckBox source = (JCheckBox)event.getSource();
+		
+		// check at least one of the elements should be ticked
+		checkTickedElements(source);
+				
+		// update the status of the drop-down list component associated with the current checkbox 
+		if (this.target == null) {
+		    return;
+		}				
+				
+		if(source.isSelected()) {
+		    target.setBackground(Color.white);
+		    target.setEnabled(true);
+		    target.setVisible(true);
+		}
+		else {
+		    target.setBackground(Color.lightGray);
+		    target.setEnabled(false);
+		    target.setVisible(false);
+		}				
+	    }
+			
+	    private void checkTickedElements(JCheckBox source) {
+		if (source.isSelected()) {
+		    return;
+		}
+				
+		boolean b = false;
+		for (int i = 0, j = metadata_checklist_model.size(); i < j; i++) {
+		    if (((MetadataElementEntry) metadata_checklist_model.get(i)).gui_object.enabled.isSelected()) {
+			b = true;
+			break;
+		    }
+		}
+				
+		// there must be at least one element selected in the list 
+		if (b == false) {
+		    Object[] options = {Dictionary.get("General.OK")};
+		    JOptionPane.showOptionDialog(Gatherer.g_man, Dictionary.get("CDM.DepositorMetadataManager.Warning"), Dictionary.get("General.Warning"), JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE, null, options, options[0]);
+		    
+		    source.setSelected(true);
+		}
+	    }
+	}
+	
+    }
+	
+    private class MetadataElementEntry implements Comparable {
+	/** namespace, used to distinguish different metadata sets and use different colors when displaying */
+	String namespace = null;
+	/** identifier, with namespace */
+	String name = null;
+	/** language independent label, without namespace, used for display in the depositor web page, eg. Title */
+	String label = null;	
+	/** type of the element: text or textarea */
+	String type = null;
+	/** description of the element, used in web page */
+	String tooltip = null;		
+	/** whether current element is selected or not */
+	boolean selected ;
+	/** GUI component object associated with this element */ 
+	MetadataElementControl gui_object = null;
+		
+	/**
+	 * Constructor
+	 * @param name Language independent identifier of the element with namespace, eg. dc.Title
+	 * @param label Language independent label of the element, without namespace, eg. Title 
+	 * @param selected Whether the current element has been selected as depositor metadata element 
+	 */
+	public MetadataElementEntry(String name, String label, boolean selected) {
+	    this.name = name;
+	    this.label = label;
+	    this.selected = selected;
+	    
+	    if (name.indexOf(".") != -1) {
+		namespace = name.substring(0, name.indexOf("."));
+	    }
+	}
+		
+	/**
+	 * Initiate the <code>MetadataElementControl<code> GUI component object associated with this element, with the specified background color  
+	 * @param background_color_name System configured color name for the background, eg. "coloring.collection_heading_background", or "coloring.collection_tree_background"
+	 * @return the initialized component object
+	 */
+	public MetadataElementControl initGUIControl (String background_color_name) {
+	    gui_object = new MetadataElementControl(this, background_color_name);
+	    return gui_object;
+	}
+	
+	/**
+	 * Get the associated GUI component
+	 * @return
+	 */
+	public MetadataElementControl getGUIControl() {
+	    return gui_object;
+	}
+		
+	/**
+	 * Set selected
+	 * @param b
+	 */
+	public void setSelected(boolean b) {
+	    this.selected = b;
+	}
+		
+	public boolean isSelected() {
+	    return gui_object.enabled.isSelected();
+	}
+		
+	/**
+	 * Get the selected type for the element
+	 * @return type
+	 */
+	public String getType() {
+	    return ((JComboBox) gui_object.value_control).getSelectedItem().toString();
+	}
+		
+	public void setToolTip (String tip) {
+	    if (tip == null) {
+		tooltip = "";
+		return;
+	    }
+	    this.tooltip = tip;
+	}
+
+	public int compareTo(Object obj) {
+	    return compareTo((MetadataElementEntry) obj);
+	}
+		
+	public int compareTo(MetadataElementEntry obj) {
+	    return this.name.compareTo(obj.name);
+	}
+	
+    }
+    
+}
Index: gli/branches/rtl-gli/src/org/greenstone/gatherer/cdm/Format.java
===================================================================
--- gli/branches/rtl-gli/src/org/greenstone/gatherer/cdm/Format.java	(revision 18351)
+++ gli/branches/rtl-gli/src/org/greenstone/gatherer/cdm/Format.java	(revision 18352)
@@ -42,5 +42,5 @@
 
     /** The default features (not all of these are in the Greenstone Developer's Guide). */
-    static final public String DEFAULT_FEATURES[] = { "", "AllowExtendedOptions", "Document", "DocumentArrowsBottom", "DocumentArrowsTop","DocumentSearchResultLinks", "DocumentButtons", "DocumentContents", "DocumentHeading", "DocumentImages", "DocumentText", "DocumentTitles", "DocumentUseHTML", "RelatedDocuments", "Search", "SearchTypes" };
+    static final public String DEFAULT_FEATURES[] = { "", "AllowExtendedOptions", "Document", "DocumentArrowsBottom", "DocumentArrowsTop","DocumentSearchResultLinks", "DocumentButtons", "DocumentContents", "DocumentHeading", "DocumentImages", "DocumentText", "DocumentTitles", "DocumentUseHTML", "NavigationBar", "RelatedDocuments", "Search", "SearchTypes" };
     /** The list of known feature parts. */
     static final public String DEFAULT_PARTS[] = { "", "DateList", "HList", "VList" };
Index: gli/branches/rtl-gli/src/org/greenstone/gatherer/cdm/FormatManager.java
===================================================================
--- gli/branches/rtl-gli/src/org/greenstone/gatherer/cdm/FormatManager.java	(revision 18351)
+++ gli/branches/rtl-gli/src/org/greenstone/gatherer/cdm/FormatManager.java	(revision 18352)
@@ -77,4 +77,7 @@
   static final private String SEARCHTYPES_DEFAULT_FORMAT = "plain,form";
   
+  static final private String NAVBAR = "NavigationBar";
+  static final private String NAVBAR_OPTION = "pulldown";
+
   static private HashMap default_format_map = null;
   
@@ -98,4 +101,5 @@
     default_format_map.put(DOCUMENTBUTTONS, DOCUMENTBUTTONS_DEFAULT_FORMAT);
     default_format_map.put(SEARCHTYPES, SEARCHTYPES_DEFAULT_FORMAT);
+    default_format_map.put(NAVBAR, NAVBAR_OPTION);
     default_format_map.put("", "");
     
Index: gli/branches/rtl-gli/src/org/greenstone/gatherer/cdm/GeneralManager.java
===================================================================
--- gli/branches/rtl-gli/src/org/greenstone/gatherer/cdm/GeneralManager.java	(revision 18351)
+++ gli/branches/rtl-gli/src/org/greenstone/gatherer/cdm/GeneralManager.java	(revision 18352)
@@ -299,8 +299,4 @@
 	    String creator_email_str = creator_emailfield.getText();
 	    creator_collectionmeta.setValue(creator_email_str);
-		// If the email is currently empty, store this email
-	    if(Configuration.getEmail() == null) {
-		Configuration.setEmail(creator_email_str); // Store the email address in the configuration
-	    }
 	    collection_extra_collectionmeta.setValue(description_textarea.getText());
 	    icon_collection_collectionmeta.setValue(icon_textfield.getText());
@@ -348,5 +344,6 @@
 			    // If we're using a remote Greenstone server, upload the image
 			    if (Gatherer.isGsdlRemote) {
-				RemoteGreenstoneServer.uploadCollectionFile(CollectionManager.getLoadedCollectionName(), collection_image_file);
+				Gatherer.remoteGreenstoneServer.uploadCollectionFile(
+                                   CollectionManager.getLoadedCollectionName(), collection_image_file);
 			    }
 			}
Index: gli/branches/rtl-gli/src/org/greenstone/gatherer/cdm/IndexOptionManager.java
===================================================================
--- gli/branches/rtl-gli/src/org/greenstone/gatherer/cdm/IndexOptionManager.java	(revision 18351)
+++ gli/branches/rtl-gli/src/org/greenstone/gatherer/cdm/IndexOptionManager.java	(revision 18352)
@@ -190,5 +190,6 @@
 	private JCheckBox casefold_checkbox = new JCheckBox();
 	private JCheckBox accentfold_checkbox = new JCheckBox();
-
+	private JCheckBox separate_cjk_checkbox =new JCheckBox();
+	
 	public StemmingControl()
 	{
@@ -197,20 +198,37 @@
 	    
 	    stem_checkbox.setText(Dictionary.get("CDM.IndexingManager.Stem"));
+	    stem_checkbox.setToolTipText(Dictionary.get("CDM.IndexingManager.Stem_Tooltip"));
 	    stem_checkbox.setActionCommand(StaticStrings.STEM_OPTION_STR);
 	    
 	    casefold_checkbox.setText(Dictionary.get("CDM.IndexingManager.Casefold"));
+	    casefold_checkbox.setToolTipText(Dictionary.get("CDM.IndexingManager.Casefold_Tooltip"));
 	    casefold_checkbox.setActionCommand(StaticStrings.CASEFOLD_OPTION_STR);
 	    
 	    accentfold_checkbox.setText(Dictionary.get("CDM.IndexingManager.Accent_fold"));
+	    accentfold_checkbox.setToolTipText(Dictionary.get("CDM.IndexingManager.Accent_fold_Tooltip"));
 	    accentfold_checkbox.setActionCommand(StaticStrings.ACCENTFOLD_OPTION_STR);
 	    // Accent-folding is currently not available for MG
 	    accentfold_checkbox.setEnabled(!build_type.equals(BuildTypeManager.BUILD_TYPE_MG));
-	    
+	
+	    separate_cjk_checkbox.setText(Dictionary.get("CDM.IndexingManager.Separate_cjk"));
+	    separate_cjk_checkbox.setToolTipText(Dictionary.get("CDM.IndexingManager.Separate_cjk_Tooltip"));
+	    separate_cjk_checkbox.setActionCommand(StaticStrings.SEPARATE_CJK_OPTION_STR);
+
 	    JPanel checkbox_panel = new JPanel();
-	    checkbox_panel.setLayout(new GridLayout(1, 3));
-	    checkbox_panel.add(stem_checkbox);
-	    checkbox_panel.add(casefold_checkbox);
-	    checkbox_panel.add(accentfold_checkbox);
-	    
+	    checkbox_panel.setLayout(new GridLayout(2, 1));
+	    
+	    JPanel stem_panel = new JPanel();
+	    stem_panel.setLayout(new GridLayout(1,3));
+	    stem_panel.add(stem_checkbox);
+	    stem_panel.add(casefold_checkbox);
+	    stem_panel.add(accentfold_checkbox);
+	    
+	    JPanel other_panel = new JPanel();
+	    other_panel.setLayout(new GridLayout(1,1));
+	    other_panel.add(separate_cjk_checkbox);
+
+	    checkbox_panel.add(stem_panel);
+	    checkbox_panel.add(other_panel);
+
 	    add(new JLabel(Dictionary.get("CDM.IndexingManager.Options")), BorderLayout.WEST);
 	    add(checkbox_panel, BorderLayout.CENTER);
@@ -227,4 +245,5 @@
 		    stem_model.addOption(StaticStrings.ACCENTFOLD_OPTION_STR);
 		}
+		separate_cjk_checkbox.setSelected(false);
 	    } 
 	    else {
@@ -238,4 +257,8 @@
 		    accentfold_checkbox.setSelected(true);
 		}
+		if (stem_model.getOption(StaticStrings.SEPARATE_CJK_OPTION_STR) != null) {
+		    separate_cjk_checkbox.setSelected(true);
+		}
+		
 		
 	    }
@@ -245,10 +268,11 @@
 	    casefold_checkbox.addActionListener(cbl);
  	    accentfold_checkbox.addActionListener(cbl);
-
+	    separate_cjk_checkbox.addActionListener(cbl);
+	    
 	    // changing stem indexes changes build settings
 	    stem_checkbox.addActionListener(CollectionDesignManager.buildcol_change_listener);
 	    casefold_checkbox.addActionListener(CollectionDesignManager.buildcol_change_listener);
  	    accentfold_checkbox.addActionListener(CollectionDesignManager.buildcol_change_listener);
-
+	    separate_cjk_checkbox.addActionListener(CollectionDesignManager.buildcol_change_listener);
 	    
 	}
@@ -258,4 +282,5 @@
 	    if (new_build_type.equals(BuildTypeManager.BUILD_TYPE_MG)) {
 		//changing to MG
+		accentfold_checkbox.setSelected(false);
 		accentfold_checkbox.setEnabled(false);
 		if (accentfold_checkbox.isSelected()) {
@@ -307,4 +332,5 @@
 	    document_checkbox = new JCheckBox();
 	    document_checkbox.setText(Dictionary.get("CDM.LevelManager.Document"));
+	    document_checkbox.setActionCommand(StaticStrings.DOCUMENT_STR);
 	    document_default_radio = new JRadioButton();
 	    document_default_radio.setBackground(Configuration.getColor("coloring.collection_tree_background", false));
@@ -316,4 +342,5 @@
 	    section_checkbox = new JCheckBox();
 	    section_checkbox.setText(Dictionary.get("CDM.LevelManager.Section"));
+	    section_checkbox.setActionCommand(StaticStrings.SECTION_STR);
 	    section_default_radio = new JRadioButton();
 	    section_default_radio.setOpaque(true);
Index: gli/branches/rtl-gli/src/org/greenstone/gatherer/cdm/MacrosManager.java
===================================================================
--- gli/branches/rtl-gli/src/org/greenstone/gatherer/cdm/MacrosManager.java	(revision 18351)
+++ gli/branches/rtl-gli/src/org/greenstone/gatherer/cdm/MacrosManager.java	(revision 18352)
@@ -217,5 +217,5 @@
 		// Users need to wait until the upload has finished before pressing Preview Collection!
 		if (Gatherer.isGsdlRemote) {
-		    RemoteGreenstoneServer.uploadCollectionFile(CollectionManager.getLoadedCollectionName(), extra_dm_file);
+		    Gatherer.remoteGreenstoneServer.uploadCollectionFile(CollectionManager.getLoadedCollectionName(), extra_dm_file);
 		}
 	    }
Index: gli/branches/rtl-gli/src/org/greenstone/gatherer/cdm/Plugin.java
===================================================================
--- gli/branches/rtl-gli/src/org/greenstone/gatherer/cdm/Plugin.java	(revision 18351)
+++ gli/branches/rtl-gli/src/org/greenstone/gatherer/cdm/Plugin.java	(revision 18352)
@@ -42,7 +42,9 @@
     private String default_process_expression = "";
     private boolean does_explode_metadata_databases = false; 
-    private boolean loading_options_failed = false;
-
-    
+    private boolean does_replace_srcdocs_with_html = false; // to work with replace_srcdoc_with_html.pl
+    /** Plugins are loaded as needed. This variable indicates 1. whether a plugin has been loaded already; 2. whether a 
+     * plugin has been successfully loaded. When both are true, has_loaded_options will be true. */
+    private boolean has_loaded_options = false;
+
     /** Constructor used in DOMProxyListModel initializations, and Library Level. Used for Base plugins (those in the list of available plugins, not ones that are in the DOMProxyList)
      */
@@ -84,7 +86,7 @@
 
 
-    public boolean didLoadingOptionsFail()
-    {
-	return loading_options_failed;
+    public boolean hasLoadedOptions()
+    {
+	return has_loaded_options;
     }
 
@@ -100,4 +102,15 @@
     }
 
+    /** Checks whether the plugin this instance is based on processes source documents that can be replaced with their Greenstone generated html variants. 
+     * This method works with replace_srcdoc_with_html.pl */
+    public boolean doesReplaceSrcDocsWithHtml()
+    {
+	//return does_replace_srcdocs_with_html;
+	Plugin base_plugin = Plugins.getPlugin(getName(), false);
+	if (base_plugin == null) {
+	  return false;
+	}
+	return base_plugin.does_replace_srcdocs_with_html;
+    }
 
     /** Checks whether this plugin instance will process the specified file (given its block_exp). */
@@ -211,8 +224,13 @@
     }
 
-
-    public void setLoadingOptionsFailed()
-    {
-	this.loading_options_failed = true;
+    // To work with replace_srcdoc_with_html.pl
+    public void setDoesReplaceSrcDocsWithHtml(boolean does_replace_srcdocs_with_html)
+    {
+	this.does_replace_srcdocs_with_html = does_replace_srcdocs_with_html;
+    }
+
+    public void setHasLoadedOptions(boolean hasLoadedOptions)
+    {
+	this.has_loaded_options = hasLoadedOptions;
     }
 }
